package com.servlet;

import java.io.IOException;
import java.util.Properties;

import javax.annotation.Resource;
import javax.ejb.EJB;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.HelloStatelessLocal;
import com.HelloStatelessRemote;

/**
 * Servlet implementation class Prova
 */
@WebServlet("/Prova")
public class Prova extends HttpServlet {
	private static final long serialVersionUID = 1L;
     
	
//	@EJB  //posso aggiungere mappedName o no. stessa cosa con resource
//	private HelloStatelessRemote beanStateless; // con @ejb si puo usare sia l interfaccia locale che remote
	
	
	@EJB(mappedName = "java:jboss/exported/HelloWorldEJBSession/HelloStateless!com.HelloStatelessRemote")
	private  HelloStatelessRemote beanStateless;
//
//	@Resource(mappedName = "java:global/HelloWorldEJBSession/HelloStateless!com.HelloStatelessLocal")
//	private  HelloStatelessLocal ejbTestCaseLocal;
	
	
	
    /**
     * @see HttpServlet#HttpServlet()
     */
    public Prova() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
	
		
		//1 modo
		System.out.println("chiamata 2 metodo tramite @EJB");
		beanStateless.prova();
		
//		
//		
//		// 2 modo di chiamare ejb
//		System.out.println("chiamata metodo tramite @Resource");
//		ejbTestCase.prova();
//		
//		
//		//3 modo di chiamare ejb con il nome local
//		System.out.println("chiamata metodo tramite @Resource");
//		ejbTestCaseLocal.prova();
//		
		response.getWriter().append("Served at: ").append(request.getContextPath());
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		doGet(request, response);
	}

	
	
	public static void main(String[] args) {
		
		try {
			
			Properties jndiProperties=new Properties();
			
			jndiProperties.put(Context.INITIAL_CONTEXT_FACTORY, "org.jboss.naming.remote.client.InitialContextFactory");
			jndiProperties.put(Context.PROVIDER_URL, "http-remoting://127.0.0.1:8080");
			jndiProperties.put(Context.SECURITY_PRINCIPAL, "username");
			jndiProperties.put(Context.SECURITY_CREDENTIALS, "password");
			          
			jndiProperties.put("jboss.naming.client.ejb.context", true);

		    Context context=new InitialContext(jndiProperties);
	
		    String jndi = "HelloWorldEJBSession/HelloStateless!com.HelloStatelessRemote";
		    HelloStatelessRemote ee = (HelloStatelessRemote) context.lookup(jndi);
		   
		   
			String i = ee.prova();
			 System.out.println("chiamata da main:"+i);
		
		} catch (NamingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
}
